## pugixml 1.4

=== scripts/CMakeLists.txt ===
project(pugixml)

cmake_minimum_required(VERSION 2.6)
set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build shared instead of static library")

if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
    SET(CMAKE_INSTALL_LIBDIR lib CACHE PATH "Output directory for libraries")
endif()

set(HEADERS ../src/pugixml.hpp ../src/pugiconfig.hpp)
set(SOURCES ${HEADERS} ../src/pugixml.cpp)

if(BUILD_SHARED_LIBS)
    add_library(pugixml SHARED ${SOURCES})
else()
    add_library(pugixml STATIC ${SOURCES})
endif()

set_target_properties(pugixml PROPERTIES VERSION 1.4 SOVERSION 1)

install(TARGETS pugixml LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${HEADERS} DESTINATION include)

## pugixml 1.2

=== debian/changelog ===
pugixml (1.2-2) unstable; urgency=low

  [ Vasudev Kamath ]
  * Fix c++-demangle architecture-dependent symbols in symbols file.
    Closes: bug#704718.
  * debian/rules:
    + Pass -v$(DEB_UPSTREAM_VERSION) to dpkg-gensymbols to avoid it
      taking debian version while reconstructing symbols file.

  [ Jonas Smedegaard ]
  * Add README.source emphasizing control.in file as *not* a
    show-stopper for contributions, referring to wiki page for details.
  * Skip copyright-checking some images.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 01 Jul 2013 02:48:14 +0200

pugixml (1.2-1) unstable; urgency=low

  [ Vasudev Kamath ]
  * Initial packaging.
    Closes: bug#697520

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 13 Jan 2013 18:47:10 +0100

=== debian/control ===
Source: pugixml
Section: libs
Priority: optional
Build-Depends: cdbs,
 debhelper,
 devscripts,
 cmake,
 d-shlibs(>= 0.48)
Maintainer: Vasudev Kamath <kamathvasudev@gmail.com>
Uploaders: Jonas Smedegaard <dr@jones.dk>
Standards-Version: 3.9.4
Homepage: http://pugixml.org/
Vcs-Git: git://git.debian.org/collab-maint/pugixml.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/pugixml.git

Package: libpugixml1
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends},
 ${cdbs:Pre-Depends}
Multi-Arch: same
Description: Light-weight C++ XML processing library
 pugixml is a lightweight C++ XML processing library with XPath
 support. It features:
  * DOM like interface with rich traversal/modification capabilities
  * Extermely fast non-validating XML parser which constructs the DOM
    tree from an XML file/buffer.
  * XPath 1.0 implementation for complex data-driven tree queries
  * Full Unicode support with Unicode interface variants and automatic
    encoding conversions.
 .
 This library is extremely portable and easy to integrate and use.
 .
 Since pugixml has a DOM parser, it can't process XML documents that do
 not fit in memory; also the parser is a non-validating one, so if you
 need DTD or XML Schema validation, the library is not for you.

Package: libpugixml-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libpugixml1 (= ${binary:Version}),
 ${misc:Depends},
 ${devlibs:Depends}
Description: Light-weight C++ XML processing library (development)
 pugixml is a lightweight C++ XML processing library with XPath
 support. It features:
  * DOM like interface with rich traversal/modification capabilities
  * Extermely fast non-validating XML parser which constructs the DOM
    tree from an XML file/buffer.
  * XPath 1.0 implementation for complex data-driven tree queries
  * Full Unicode support with Unicode interface variants and automatic
    encoding conversions.
 .
 This package provides required development header files which allows
 integrating pugixml with your application.

Package: libpugixml1-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends},
 libpugixml1 (= ${binary:Version})
Description: Light-weight C++ XML processing library - debug symbols
 pugixml is a lightweight C++ XML processing library with XPath
 support. It features:
  * DOM like interface with rich traversal/modification capabilities
  * Extermely fast non-validating XML parser which constructs the DOM
    tree from an XML file/buffer.
  * XPath 1.0 implementation for complex data-driven tree queries
  * Full Unicode support with Unicode interface variants and automatic
    encoding conversions.
 .
 This package contains the debug symbols.

Package: pugixml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Light-weight C++ XML processing library (documentation)
 pugixml is a lightweight C++ XML processing library with XPath
 support. It features:
  * DOM like interface with rich traversal/modification capabilities
  * Extermely fast non-validating XML parser which constructs the DOM
    tree from an XML file/buffer.
  * XPath 1.0 implementation for complex data-driven tree queries
  * Full Unicode support with Unicode interface variants and automatic
    encoding conversions.
 .
 This package contains API documentation.
 .

=== debian/rules ===
#!/usr/bin/make -f

debian/control:: debian/control.in
DEB_PHONY_RULES += debina/control.in
debian/control.in::
	sed -e 's/__LIBPKGNAME__/$(libpkgname)/g' <debian/control.in.in >debian/control.in


include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk
-include /usr/share/cdbs/1/rules/upstream-tarball.mk

include /usr/share/cdbs/1/class/cmake.mk

stem = pugixml
major = $(firstword $(subst .,$(space),$(DEB_UPSTREAM_VERSION)))
libname = lib$(stem)
libpkgname = lib$(stem)$(major)
devpkgname = lib$(stem)-dev

# Handle upstream release
DEB_UPSTREAM_URL = http://pugixml.googlecode.com/files/
DEB_UPSTREAM_URL_MD5 = 477f4a7d75af0383f52ee6622b3f6035

# Skip checking some images (in addition to the defaults)
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(docs/images/.*\.png|debian/(changelog|copyright(|_hints|_newhints)))$

# Build the shared library
DEB_CMAKE_EXTRA_FLAGS += -DBUILD_SHARED_LIBS=1

# We need this to build the package
CDBS_BUILD_DEPENDS += cmake, d-shlibs(>= 0.48)

# Supress optional build dependencies
CDBS_BUILD_DEPENDS_rules_upstream_tarball =
CDBS_BUILD_DEPENDS_rules_utils_copyright_check =

# Multiarch quirks (should ideally be resolved automagically)
CDBS_BUILD_DEPENDS_rules_debhelper_buildinfo =
CDBS_BUILD_DEPENDS_rules_buildcore_pkgrel =
CDBS_PREDEPENDS = $(if $(DEB_HOST_MULTIARCH),multiarch-support)

# Fix the cmake invocation path
DEB_SRCDIR = scripts

# Docs installation
DEB_INSTALL_DOCS_$(stem)-doc += docs/manual docs/images docs/manual.html docs/pugixml.css docs/quickstart.html

# Install examples
DEB_INSTALL_EXAMPLES_$(devpkgname) += docs/samples

# Use only upstream version for dpkg-gensymbols
DEB_DH_MAKESHLIBS_ARGS_$(libpkgname) += -- -v$(DEB_UPSTREAM_VERSION)

# avoid unneeded .la file
binary-post-install/$(libpkgname):: debian/stamp-local-strip-la
debian/stamp-local-strip-la: binary-install/$(libpkgname)
	find debian -type f -name '*.la' -delete
	touch $@
clean::
	rm -f debian/stamp-local-strip-la

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
binary-post-install/$(libpkgname) binary-post-install/$(devpkgname):: debian/stamp-local-shlibs-$(libname)
debian/stamp-local-shlibs-$(libname): binary-install/$(libpkgname) binary-install/$(devpkgname) debian/stamp-local-strip-la
	d-shlibmove --commit \
		--devunversioned \
		--multiarch \
		--override s/$(libname)$(major)-dev/$(libname)-dev/ \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		debian/tmp/usr/lib/$(libname).so
		touch $@
clean::
	rm -f debian/stamp-local-shlibs-$(libname)

=== debian/watch ===
version = 3
http://code.google.com/p/pugixml/downloads/list .*/pugixml-(\d[\d.]+)\.tar\.gz

## pugixml 1.4

=== debian/changelog ===
pugixml (1.4-1) unstable; urgency=medium

  * Use github URL in watch file, code.google.com stopped providing
    download features.
  * Use github URL for DEB_UPSTREAM_URL and update md5sum for new release.
  * Imported Upstream version 1.4
    Closes: bug#762260, Thanks to Ghislain Antony Vaillant.
  * Refreshed patch 01-enable_staticlib_generation.patch and renamed it as
    per guidelines in patches/README file.
  * Regenerated symbols file using pkgkde-symbols-helper.
  * Introduced pkg-kde-symbols tools as build-dependency.
  * Bump Standards-Version to 3.9.5, no change required to package source.
  * Use canonical anonscm.debian.org for Vcs-Git field.
  * Use cgit URL for Vcs-Browser field.
  * Bump compat to 9 to handle multi-arch debug symbols, debhelper
    dependency is now >=9.
  * Mark the -dbg package as multi-arch same.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Sun, 21 Sep 2014 22:09:39 +0530

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,17 @@
 Section: libs
 Priority: optional
 Build-Depends: cdbs,
- debhelper,
+ debhelper (>= 9~),
  devscripts,
  cmake,
- d-shlibs(>= 0.48)
+ d-shlibs(>= 0.48),
+ pkg-kde-tools
 Maintainer: Vasudev Kamath <kamathvasudev@gmail.com>
 Uploaders: Jonas Smedegaard <dr@jones.dk>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://pugixml.org/
-Vcs-Git: git://git.debian.org/collab-maint/pugixml.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/pugixml.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/pugixml.git
+Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/pugixml.git
 
 Package: libpugixml1
 Section: libs
@@ -59,6 +60,7 @@
 
 Package: libpugixml1-dbg
 Architecture: any
+Multi-Arch: same
 Section: debug
 Priority: extra
 Depends: ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -19,8 +19,8 @@
 devpkgname = lib$(stem)-dev
 
 # Handle upstream release
-DEB_UPSTREAM_URL = http://pugixml.googlecode.com/files/
-DEB_UPSTREAM_URL_MD5 = 477f4a7d75af0383f52ee6622b3f6035
+DEB_UPSTREAM_URL = https://github.com/zeux/pugixml/releases/download/v$(DEB_UPSTREAM_VERSION)
+DEB_UPSTREAM_TARBALL_MD5 = 7c56c91cfe3ecdee248a8e4892ef5781
 
 # Skip checking some images (in addition to the defaults)
 DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(docs/images/.*\.png|debian/(changelog|copyright(|_hints|_newhints)))$
@@ -29,7 +29,7 @@
 DEB_CMAKE_EXTRA_FLAGS += -DBUILD_SHARED_LIBS=1
 
 # We need this to build the package
-CDBS_BUILD_DEPENDS += cmake, d-shlibs(>= 0.48)
+CDBS_BUILD_DEPENDS += cmake, d-shlibs(>= 0.48), pkg-kde-tools
 
 # Supress optional build dependencies
 CDBS_BUILD_DEPENDS_rules_upstream_tarball =

=== debian/watch ===
version = 3
#http://code.google.com/p/pugixml/downloads/list .*/pugixml-(\d[\d.]+)\.tar\.gz
https://github.com/zeux/pugixml/tags .*/v(\d.*)\.(?:tbz2|tgz|txz|tar\.(?:gz|bz2|xz))

## pugixml 1.7

=== Makefile ===
.SUFFIXES:
MAKEFLAGS+=-r

config=debug
defines=standard

BUILD=build/make-$(CXX)-$(config)-$(defines)

SOURCES=src/pugixml.cpp $(filter-out tests/fuzz_%,$(wildcard tests/*.cpp))
EXECUTABLE=$(BUILD)/test

VERSION=$(shell sed -n 's/.*version \(.*\).*/\1/p' src/pugiconfig.hpp)
RELEASE=$(shell git ls-files src docs/*.html docs/*.css docs/samples docs/images scripts contrib readme.txt)

CXXFLAGS=-g -Wall -Wextra -Werror -pedantic -Wundef -Wshadow -Wold-style-cast -Wcast-align
LDFLAGS=

ifeq ($(config),release)
	CXXFLAGS+=-O3 -DNDEBUG
endif

ifeq ($(config),coverage)
	CXXFLAGS+=-coverage
	LDFLAGS+=-coverage
endif

ifeq ($(config),sanitize)
	CXXFLAGS+=-fsanitize=address
	LDFLAGS+=-fsanitize=address

	ifneq ($(shell uname),Darwin)
		CXXFLAGS+=-fsanitize=undefined
		LDFLAGS+=-fsanitize=undefined
	endif
endif

ifeq ($(config),analyze)
	CXXFLAGS+=--analyze
endif

ifneq ($(defines),standard)
	COMMA=,
	CXXFLAGS+=-D $(subst $(COMMA), -D ,$(defines))
endif

ifneq ($(findstring PUGIXML_NO_EXCEPTIONS,$(defines)),)
	CXXFLAGS+=-fno-exceptions
endif

ifeq ($(findstring PUGIXML_NO_CXX11,$(defines)),)
	# Can't use std=c++11 since Travis-CI has gcc 4.6.3
	CXXFLAGS+=-std=c++0x
endif

OBJECTS=$(SOURCES:%=$(BUILD)/%.o)

all: $(EXECUTABLE)

ifeq ($(config),coverage)
test: $(EXECUTABLE)
	-@find $(BUILD) -name '*.gcda' -exec rm {} +
	./$(EXECUTABLE)
	@gcov -b -o $(BUILD)/src/ pugixml.cpp.gcda | sed -e '/./{H;$!d;}' -e 'x;/pugixml.cpp/!d;'
	@find . -name '*.gcov' -and -not -name 'pugixml.cpp.gcov' -exec rm {} +
else
test: $(EXECUTABLE)
	./$(EXECUTABLE)
endif

fuzz:
	@mkdir -p $(BUILD)
	$(AFL)/afl-clang++ tests/fuzz_parse.cpp tests/allocator.cpp src/pugixml.cpp $(CXXFLAGS) -o $(BUILD)/fuzz_parse
	$(AFL)/afl-fuzz -i tests/data_fuzz_parse -o $(BUILD)/fuzz_parse_out -x $(AFL)/testcases/_extras/xml/ -- $(BUILD)/fuzz_parse @@

clean:
	rm -rf $(BUILD)

release: build/pugixml-$(VERSION).tar.gz build/pugixml-$(VERSION).zip

docs: docs/quickstart.html docs/manual.html

build/pugixml-%: .FORCE | $(RELEASE)
	@mkdir -p $(BUILD)
	perl tests/archive.pl $@ $|

$(EXECUTABLE): $(OBJECTS)
	$(CXX) $(OBJECTS) $(LDFLAGS) -o $@

$(BUILD)/%.o: %
	@mkdir -p $(dir $@)
	$(CXX) $< $(CXXFLAGS) -c -MMD -MP -o $@

-include $(OBJECTS:.o=.d)

.SECONDEXPANSION:
docs/%.html: docs/%.adoc $$(shell sed -n 's/include\:\:\(.*\)\[.*/docs\/\1/p' docs/%.adoc)
	asciidoctor -b html5 -a version=$(VERSION) $< -o $@

.PHONY: all test clean release .FORCE

=== debian/changelog ===
pugixml (1.7-2) unstable; urgency=medium

  * Update symbols file to include all architecture.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Fri, 06 Nov 2015 22:44:36 +0530

pugixml (1.7-1) unstable; urgency=medium

  * New upstream release.
    + Introduced a new compact tree storage mode that takes significantly
      less memory (2-5x smaller DOM) at some performance cost.
    + New integer parsing/formatting implementation (3-5x faster at
      getting/setting integers).
    + Added format_indent_attributes that makes the resulting XML
      friendlier to line diff/merge tools.
    + Fix Clang 3.7 crashes in out-of-memory cases (C++ DR 1748)
  * Refresh patch 2001 and 2002 for new release.
  * Update symbols file for new release.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Sun, 01 Nov 2015 21:46:04 +0530

pugixml (1.6-2) unstable; urgency=medium

  * Update package name in symbols file

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Thu, 08 Oct 2015 20:23:59 +0530

pugixml (1.6-1) unstable; urgency=medium

  [ upstream ]
  * New release.
    + Fix translate and normalize-space XPath functions to no longer
      return internal NUL characters.
    + Fix buffer overrun on malformed comments inside DOCTYPE sections.
    + Have attribute/text values use more digits when printing floating
      point numbers to guarantee round-tripping.

  [ Vasudev Kamath ]
  * Drop doc/manual folder no longer shipped upstream.
  * Re-add symbols file, accidentally dropped in gcc v5 transition.
  * Refresh patch 2001 with new upstream changes.
  * Add patch 2002 to avoid linking to external data in documentation
    (potential privacy issue).
  * Update copyright info:
    + Extend coverage for upstream author.
    + Drop copyright statement for docs/pugixml.css.
    + Extend coverage for myself.
    + Extend coverage for Jonas.

  [ Jonas Smedegaard ]
  * Fix bump DEP3 Last-Update header for patch 2001.
  * Update copyright info:
    + Drop unused License section BSL-1.0.
    + Rewrap Licenses at 72 chars.
    + Fix source URL, and add alternate git source URL.
    + Bump packaging license to GPL-3+.
    + Fix coverage for myself to exclude 2014.
    + Add copyright and licensing boilerplate to rules file (based on
      copyright file info, making the latter fully reflective).
  * Modernize CDBS handling:
    + Unconditionally include snippet upstream-tarball.mk and stop
      suppress optional build-dependencies: All satisfied even in
      oldstable.
    + Drop obsolete multiarch quirks.
  * Update package relations:
    + Fix tighten build-dependency on d-shlibs: Needed for v5 option.
    + Build-depend on dh-buildinfo.
    + Relax build-dependency on debhelper: Needed version satisfied even
      in oldstable.
  * Exclude .la files with d-shlibs (not custom rules targets).
  * Fix track tagged releases (not different "released" ones).
  * Simplify watch file.
  * Modernize git-buildpackage config: Avoid git- prefix.
  * Resolve stem from packaging, and major from source (not packaging).

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 06 Oct 2015 17:38:33 +0200

pugixml (1.4-3) unstable; urgency=medium

  * Re-release to unstable.
    Still closes: bug#791250.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 17 Aug 2015 14:58:59 +0200

pugixml (1.4-2) experimental; urgency=medium

  [ Andreas Tille ]
  * Declare compliance with Debian Policy 3.9.6.
  * gcc-5 transition.
    Closes: bug#791250.

  [ Jonas Smedegaard ]
  * Update copyright info:
    + Extend coverage for main upstream author to include current year.
    + Merge same-author same-license Files sections.
    + Use License-Grant and License-Reference fields. Thanks to Ben Finney.
  * Override lintian regarding license in License-Reference field.
    See bug#786450.
  * Override lintian regarding build-depending unversioned on debhelper.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 17 Aug 2015 11:21:16 +0200

=== debian/control ===
--- 
+++ 
@@ -2,26 +2,28 @@
 Section: libs
 Priority: optional
 Build-Depends: cdbs,
- debhelper (>= 9~),
  devscripts,
+ debhelper,
+ dh-buildinfo,
  cmake,
- d-shlibs(>= 0.48),
- pkg-kde-tools
+ pkg-kde-tools,
+ d-shlibs (>= 0.61~)
 Maintainer: Vasudev Kamath <kamathvasudev@gmail.com>
 Uploaders: Jonas Smedegaard <dr@jones.dk>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://pugixml.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/pugixml.git
 Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/pugixml.git
 
-Package: libpugixml1
+Package: libpugixml1v5
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends},
  ${misc:Depends}
-Pre-Depends: ${misc:Pre-Depends},
- ${cdbs:Pre-Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
+Conflicts: libpugixml1
+Replaces: libpugixml1
 Description: Light-weight C++ XML processing library
  pugixml is a lightweight C++ XML processing library with XPath
  support. It features:
@@ -42,7 +44,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libpugixml1 (= ${binary:Version}),
+Depends: libpugixml1v5 (= ${binary:Version}),
  ${misc:Depends},
  ${devlibs:Depends}
 Description: Light-weight C++ XML processing library (development)
@@ -58,13 +60,15 @@
  This package provides required development header files which allows
  integrating pugixml with your application.
 
-Package: libpugixml1-dbg
+Package: libpugixml1v5-dbg
 Architecture: any
 Multi-Arch: same
 Section: debug
 Priority: extra
 Depends: ${misc:Depends},
- libpugixml1 (= ${binary:Version})
+ libpugixml1v5 (= ${binary:Version})
+Conflicts: libpugixml1-dbg
+Replaces: libpugixml1-dbg
 Description: Light-weight C++ XML processing library - debug symbols
  pugixml is a lightweight C++ XML processing library with XPath
  support. It features:
@@ -92,4 +96,3 @@
     encoding conversions.
  .
  This package contains API documentation.
- .

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2013, 2015 Jonas Smedegaard <dr@jones.dk>
# Copyright © 2013-2015 Vasudev Kamath <kamathvasudev@gmail.com>
# Description: Main Debian packaging script for pugixml
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# This needs to declared/run before including CDBS snippets
stem = $(DEB_SOURCE_PACKAGE)
major := $(shell perl -ne '/\bSOVERSION +(\d+)/ and print $$1' scripts/CMakeLists.txt)
lib = lib$(stem)
# TODO: drop v5 suffix when major version > 1
pkg-lib = lib$(stem)$(major)v5
debian/control:: debian/control.in
DEB_PHONY_RULES += debina/control.in
debian/control.in::
	sed \
		-e 's/__PKG-LIB__/$(pkg-lib)/g' \
		<debian/control.in.in \
		>debian/control.in

include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk

pkg-dev = lib$(stem)-dev
pkg-doc = $(stem)-doc
pkg-dbg = $(pkg-lib)-dbg

# Handle upstream release
DEB_UPSTREAM_URL = https://github.com/zeux/pugixml/archive
DEB_UPSTREAM_TARBALL_BASENAME = v$(DEB_UPSTREAM_TARBALL_VERSION)

# Build-depend unversioned on debhelper
#  TODO: Drop when adopted in cdbs
CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper

# Skip checking some images (in addition to the defaults)
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(docs/images/.*\.png|debian/(changelog|copyright(|_hints|_newhints)))$

# Build the shared library
DEB_CMAKE_EXTRA_FLAGS += -DBUILD_SHARED_LIBS=1

# We need this to build the package
CDBS_BUILD_DEPENDS +=, cmake, pkg-kde-tools

# Fix the cmake invocation path
DEB_SRCDIR = scripts

# Docs installation
DEB_INSTALL_DOCS_$(pkg-doc) += docs/images docs/manual.html docs/quickstart.html

# Install examples
DEB_INSTALL_EXAMPLES_$(pkg-dev) += docs/samples

# Use only upstream version for dpkg-gensymbols
DEB_DH_MAKESHLIBS_ARGS_$(pkg-lib) += -- -v$(DEB_UPSTREAM_VERSION)

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
#  * Recent version needed for v5 option
# TODO: drop v5 option when major version > 1
CDBS_BUILD_DEPENDS +=, d-shlibs (>= 0.61~)
binary-post-install/$(pkg-lib) binary-post-install/$(pkg-dev):: \
 debian/stamp-local-shlibs-$(lib)
debian/stamp-local-shlibs-$(lib): \
 binary-install/$(pkg-lib) binary-install/$(pkg-dev)
	d-shlibmove --commit \
		--devunversioned \
		--exclude-la \
		--multiarch \
		--v5 \
		--override s/$(lib)$(major)-dev/$(lib)-dev/ \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		debian/tmp/usr/lib/$(lib).so
		touch $@
clean::
	rm -f debian/stamp-local-shlibs-$(lib)

## pugixml 1.8.1

=== Makefile ===
--- 
+++ 
@@ -3,16 +3,18 @@
 
 config=debug
 defines=standard
+cxxstd=c++11
+# set cxxstd=any to disable use of -std=...
 
-BUILD=build/make-$(CXX)-$(config)-$(defines)
+BUILD=build/make-$(CXX)-$(config)-$(defines)-$(cxxstd)
 
 SOURCES=src/pugixml.cpp $(filter-out tests/fuzz_%,$(wildcard tests/*.cpp))
 EXECUTABLE=$(BUILD)/test
 
 VERSION=$(shell sed -n 's/.*version \(.*\).*/\1/p' src/pugiconfig.hpp)
-RELEASE=$(shell git ls-files src docs/*.html docs/*.css docs/samples docs/images scripts contrib readme.txt)
+RELEASE=$(shell git ls-files src docs/*.html docs/*.css docs/samples docs/images scripts contrib CMakeLists.txt readme.txt)
 
-CXXFLAGS=-g -Wall -Wextra -Werror -pedantic -Wundef -Wshadow -Wold-style-cast -Wcast-align
+CXXFLAGS=-g -Wall -Wextra -Werror -pedantic -Wundef -Wshadow -Wcast-align -Wcast-qual -Wold-style-cast
 LDFLAGS=
 
 ifeq ($(config),release)
@@ -47,9 +49,8 @@
 	CXXFLAGS+=-fno-exceptions
 endif
 
-ifeq ($(findstring PUGIXML_NO_CXX11,$(defines)),)
-	# Can't use std=c++11 since Travis-CI has gcc 4.6.3
-	CXXFLAGS+=-std=c++0x
+ifneq ($(cxxstd),any)
+	CXXFLAGS+=-std=$(cxxstd)
 endif
 
 OBJECTS=$(SOURCES:%=$(BUILD)/%.o)
@@ -60,7 +61,7 @@
 test: $(EXECUTABLE)
 	-@find $(BUILD) -name '*.gcda' -exec rm {} +
 	./$(EXECUTABLE)
-	@gcov -b -o $(BUILD)/src/ pugixml.cpp.gcda | sed -e '/./{H;$!d;}' -e 'x;/pugixml.cpp/!d;'
+	@gcov -o $(BUILD)/src/ pugixml.cpp.gcda | sed -e '/./{H;$!d;}' -e 'x;/pugixml.cpp/!d;'
 	@find . -name '*.gcov' -and -not -name 'pugixml.cpp.gcov' -exec rm {} +
 else
 test: $(EXECUTABLE)
@@ -81,7 +82,7 @@
 
 build/pugixml-%: .FORCE | $(RELEASE)
 	@mkdir -p $(BUILD)
-	perl tests/archive.pl $@ $|
+	python tests/archive.py $@ pugixml-$(VERSION) $|
 
 $(EXECUTABLE): $(OBJECTS)
 	$(CXX) $(OBJECTS) $(LDFLAGS) -o $@

=== debian/changelog ===
pugixml (1.8.1-7) unstable; urgency=medium

  * Fix FTCBFS: Closes: #-1, Thanks to Helmut Grohne.
    + Honour DEB_BUILD_OPTIONS=nocheck.
    + Always use a multiarch install layout.
  * Mark package compliance with Debian Policy 4.1.1.

 -- Vasudev Kamath <vasudev@copyninja.info>  Wed, 01 Nov 2017 10:48:54 +0530

pugixml (1.8.1-6) unstable; urgency=medium

  * Drop multi-arch tag for now from libpugixml-dev.
    Closes: bug#874243. Thanks to Helmut Grohne.

 -- Vasudev Kamath <vasudev@copyninja.info>  Fri, 15 Sep 2017 20:49:03 +0530

pugixml (1.8.1-5) unstable; urgency=medium

  * Fix revive symbols seemingly wrongly dropped since 1.7-1.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 18 Aug 2017 15:37:07 +0200

pugixml (1.8.1-4) unstable; urgency=medium

  * Tighten major version resolving used for our packaging.
  * Update git-buildpackage config: Filter any .gitignore file.
  * Modernize Vcs-* fields: Use git (not cgit) in path.
  * Declare compliance with Debian Policy 4.0.1.
  * Advertise DEP3 format in patch headers.
  * Fix mark patch 2002 as not needing upstreaming.
  * Drop obsolete lintian override regarding debhelper 9.
  * Tighten experimental release resolving used for our packaging.
  * Fix use pkg-kde-tools symbolshelper.
  * Use d-shlibs (not dh-exec) to install pkgconfig.
    Stop build-depend on dh-exec.
  * Fix avoid using only upstream version for dpkg-gensymbols: A patch
    may affect symbols.
  * Update copyright info: Extend coverage for myself.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 18 Aug 2017 14:27:31 +0200

pugixml (1.8.1-3) unstable; urgency=medium

  * Fix the Vcs-Git URL.
    Closes: bug#868010. Thanks to Kunal Mehta.
  * Fix the install path for pkgconfig file.
    Closes: bug#849810. Thanks to Kunal Mehta.
  * debian/control:
    + Mark package as compliant with Debian Policy 4.0.0.
    + Drop -dbg package in favor of automatically generated -dbgsym
      package.
  * debian/rules:
    + Add dh_strip argument --dbgsym-migration to allow clean migration
      from libpugixml1v5-dbg to libpugixml1v5-dbgsym.
  * Fix the typo  in source lintian override.

 -- Vasudev Kamath <vasudev@copyninja.info>  Sat, 15 Jul 2017 13:44:10 +0530

pugixml (1.8.1-2) unstable; urgency=medium

  * Update symbol file for all architecture (except m68k and sh4).

 -- Vasudev Kamath <vasudev@copyninja.info>  Wed, 21 Jun 2017 20:19:26 +0530

pugixml (1.8.1-1) unstable; urgency=medium

  * Import new upstream version 1.8.
  * debian/rules:
    + Drop upstream-tarball.mk snippets in favor of debian/watch.
    + Update location of CMakeLists.txt for capturing SOVERSION.
    + Relax symbol file generation on experimental.
    + Enable tests and pkg-config file generation.
    + Build depend on dh-exec for installing pkg-config files to
      multi-arch path.
    + Install upstream shipped cmake files.
  * debian/patches:
    + Refresh patches 2001 and 2002 with new upstream release.
    + Introduce patch 2003 to link test binary with static library to
      avoid FTBFS.
    + Introduce patch 2004 to avoid installing into version suffixed
      directory.
  * Update copyright info:
    + Extend copyright period for upstream.
    + Extend copyright period for myself on Debian folder.
  * Add copyright-check maintainer script to the source and drop build
    time copyright check.
  * debian/control:
    + Update my email address in maintainer field.
    + Mark package compliance with Debian policy 3.9.8.
    + Use secure URL for Vcs-* fields.
  * Update symbols file for 1.8.1 for i386 architecture.

 -- Vasudev Kamath <vasudev@copyninja.info>  Sun, 18 Jun 2017 11:01:32 +0530

=== debian/control ===
--- 
+++ 
@@ -2,18 +2,17 @@
 Section: libs
 Priority: optional
 Build-Depends: cdbs,
- devscripts,
  debhelper,
  dh-buildinfo,
  cmake,
- pkg-kde-tools,
- d-shlibs (>= 0.61~)
-Maintainer: Vasudev Kamath <kamathvasudev@gmail.com>
+ d-shlibs (>= 0.61~),
+ pkg-kde-tools
+Maintainer: Vasudev Kamath <vasudev@copyninja.info>
 Uploaders: Jonas Smedegaard <dr@jones.dk>
-Standards-Version: 3.9.6
+Standards-Version: 4.1.1
 Homepage: http://pugixml.org/
-Vcs-Git: git://anonscm.debian.org/collab-maint/pugixml.git
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/pugixml.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/pugixml.git
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/pugixml.git
 
 Package: libpugixml1v5
 Section: libs
@@ -43,7 +42,6 @@
 Package: libpugixml-dev
 Section: libdevel
 Architecture: any
-Multi-Arch: same
 Depends: libpugixml1v5 (= ${binary:Version}),
  ${misc:Depends},
  ${devlibs:Depends}
@@ -60,27 +58,6 @@
  This package provides required development header files which allows
  integrating pugixml with your application.
 
-Package: libpugixml1v5-dbg
-Architecture: any
-Multi-Arch: same
-Section: debug
-Priority: extra
-Depends: ${misc:Depends},
- libpugixml1v5 (= ${binary:Version})
-Conflicts: libpugixml1-dbg
-Replaces: libpugixml1-dbg
-Description: Light-weight C++ XML processing library - debug symbols
- pugixml is a lightweight C++ XML processing library with XPath
- support. It features:
-  * DOM like interface with rich traversal/modification capabilities
-  * Extermely fast non-validating XML parser which constructs the DOM
-    tree from an XML file/buffer.
-  * XPath 1.0 implementation for complex data-driven tree queries
-  * Full Unicode support with Unicode interface variants and automatic
-    encoding conversions.
- .
- This package contains the debug symbols.
-
 Package: pugixml-doc
 Section: doc
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 # -*- mode: makefile; coding: utf-8 -*-
-# Copyright © 2013, 2015 Jonas Smedegaard <dr@jones.dk>
+# Copyright © 2013, 2015, 2017 Jonas Smedegaard <dr@jones.dk>
 # Copyright © 2013-2015 Vasudev Kamath <kamathvasudev@gmail.com>
 # Description: Main Debian packaging script for pugixml
 #
@@ -19,7 +19,7 @@
 
 # This needs to declared/run before including CDBS snippets
 stem = $(DEB_SOURCE_PACKAGE)
-major := $(shell perl -ne '/\bSOVERSION +(\d+)/ and print $$1' scripts/CMakeLists.txt)
+major := $(shell grep -Po '\bSOVERSION +\K\d+' CMakeLists.txt)
 lib = lib$(stem)
 # TODO: drop v5 suffix when major version > 1
 pkg-lib = lib$(stem)$(major)v5
@@ -31,8 +31,7 @@
 		<debian/control.in.in \
 		>debian/control.in
 
-include /usr/share/cdbs/1/rules/upstream-tarball.mk
-include /usr/share/cdbs/1/rules/utils.mk
+include /usr/share/dpkg/architecture.mk
 include /usr/share/cdbs/1/class/cmake.mk
 include /usr/share/cdbs/1/rules/debhelper.mk
 
@@ -40,25 +39,20 @@
 pkg-doc = $(stem)-doc
 pkg-dbg = $(pkg-lib)-dbg
 
-# Handle upstream release
-DEB_UPSTREAM_URL = https://github.com/zeux/pugixml/archive
-DEB_UPSTREAM_TARBALL_BASENAME = v$(DEB_UPSTREAM_TARBALL_VERSION)
+# resolve experimental release
+EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_SUITE))
 
-# Build-depend unversioned on debhelper
-#  TODO: Drop when adopted in cdbs
-CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper
-
-# Skip checking some images (in addition to the defaults)
-DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(docs/images/.*\.png|debian/(changelog|copyright(|_hints|_newhints)))$
+# relax symbols check when targeting experimental
+export DPKG_GENSYMBOLS_CHECK_LEVEL=$(if $(EXP_RELEASE),0,1)
 
 # Build the shared library
-DEB_CMAKE_EXTRA_FLAGS += -DBUILD_SHARED_LIBS=1
+DEB_CMAKE_EXTRA_FLAGS += -DBUILD_PKGCONFIG=1 -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)
+ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+DEB_CMAKE_EXTRA_FLAGS += -DBUILD_TESTS=1
+endif
 
 # We need this to build the package
-CDBS_BUILD_DEPENDS +=, cmake, pkg-kde-tools
-
-# Fix the cmake invocation path
-DEB_SRCDIR = scripts
+CDBS_BUILD_DEPENDS +=, cmake
 
 # Docs installation
 DEB_INSTALL_DOCS_$(pkg-doc) += docs/images docs/manual.html docs/quickstart.html
@@ -66,8 +60,8 @@
 # Install examples
 DEB_INSTALL_EXAMPLES_$(pkg-dev) += docs/samples
 
-# Use only upstream version for dpkg-gensymbols
-DEB_DH_MAKESHLIBS_ARGS_$(pkg-lib) += -- -v$(DEB_UPSTREAM_VERSION)
+# Drop -dbg package in favor of auto generated -dbgsym
+DEB_DH_STRIP_ARGS = --dbgsym-migration="$(pkg-lib)-dbg (<< 1.8.1-3~)"
 
 # Let d-shlibs calculate development package dependencies
 #  and handle shared library install
@@ -85,7 +79,15 @@
 		--v5 \
 		--override s/$(lib)$(major)-dev/$(lib)-dev/ \
 		--movedev "debian/tmp/usr/include/*" usr/include/ \
-		debian/tmp/usr/lib/$(lib).so
+		--movedev "debian/tmp/usr/lib/*/cmake/pugixml/*" \
+			usr/share/$(lib)-dev/cmake \
+		--movedev "debian/tmp/usr/lib/pkgconfig/*" \
+			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
+		debian/tmp/usr/lib/*/$(lib).so
 		touch $@
 clean::
 	rm -f debian/stamp-local-shlibs-$(lib)
+
+# track symbols using pkgkde-symbolshelper
+CDBS_BUILD_DEPENDS +=, pkg-kde-tools
+include /usr/share/pkg-kde-tools/makefiles/1/cdbs/symbolshelper.mk

## pugixml 1.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(pugixml)

option(BUILD_SHARED_LIBS "Build shared instead of static library" OFF)
option(BUILD_TESTS "Build tests" OFF)
option(BUILD_PKGCONFIG "Build in PKGCONFIG mode" OFF)

set(BUILD_DEFINES "" CACHE STRING "Build defines")

if(MSVC)
	option(STATIC_CRT "Use static CRT libraries" OFF)

	# Rewrite command line flags to use /MT if necessary
	if(STATIC_CRT)
		foreach(flag_var
				CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
				CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
			if(${flag_var} MATCHES "/MD")
				string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
			endif(${flag_var} MATCHES "/MD")
		endforeach(flag_var)
	endif()
endif()

# Pre-defines standard install locations on *nix systems.
include(GNUInstallDirs)
mark_as_advanced(CLEAR CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_INCLUDEDIR)

set(HEADERS src/pugixml.hpp src/pugiconfig.hpp)
set(SOURCES src/pugixml.cpp)

if(DEFINED BUILD_DEFINES)
	foreach(DEFINE ${BUILD_DEFINES})
		add_definitions("-D" ${DEFINE})
	endforeach()
endif()

if(BUILD_SHARED_LIBS)
	add_library(pugixml SHARED ${HEADERS} ${SOURCES})
else()
	add_library(pugixml STATIC ${HEADERS} ${SOURCES})
endif()

# Export symbols for shared library builds
if(BUILD_SHARED_LIBS AND MSVC)
	target_compile_definitions(pugixml PRIVATE "PUGIXML_API=__declspec(dllexport)")
endif()

# Enable C++11 long long for compilers that are capable of it
if(NOT ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STRLESS 3.1 AND ";${CMAKE_CXX_COMPILE_FEATURES};" MATCHES ";cxx_long_long_type;")
	target_compile_features(pugixml PUBLIC cxx_long_long_type)
endif()

set_target_properties(pugixml PROPERTIES VERSION 1.9 SOVERSION 1)
get_target_property(PUGIXML_VERSION_STRING pugixml VERSION)

if(BUILD_PKGCONFIG)
	# Install library into its own directory under LIBDIR
	set(INSTALL_SUFFIX /pugixml-${PUGIXML_VERSION_STRING})
endif()

target_include_directories(pugixml PUBLIC
	$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/src>
	$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}${INSTALL_SUFFIX}>)

install(TARGETS pugixml EXPORT pugixml-config
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}${INSTALL_SUFFIX}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}${INSTALL_SUFFIX}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}${INSTALL_SUFFIX})
install(EXPORT pugixml-config DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pugixml)

if(BUILD_PKGCONFIG)
	configure_file(scripts/pugixml.pc.in ${PROJECT_BINARY_DIR}/pugixml.pc @ONLY)
	install(FILES ${PROJECT_BINARY_DIR}/pugixml.pc DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig)
endif()

if(BUILD_TESTS)
	file(GLOB TEST_SOURCES tests/*.cpp)
	file(GLOB FUZZ_SOURCES tests/fuzz_*.cpp)
	list(REMOVE_ITEM TEST_SOURCES ${FUZZ_SOURCES})

	add_executable(check ${TEST_SOURCES})
	target_link_libraries(check pugixml)
	add_custom_command(TARGET check POST_BUILD COMMAND check WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif()

=== debian/changelog ===
pugixml (1.9-3) unstable; urgency=medium

  * Team upload
  * Fixup dev package creation, cmake was put in wrong place
    (Closes: #929792)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 31 May 2019 13:00:23 +0200

pugixml (1.9-2) unstable; urgency=medium

  * Upload to unstable
  * Disable new test that fails on buildd, but not on local
    sbuild/pbuilder, maybe some restrictions in builders configuration

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 30 Jul 2018 12:15:48 +0200

pugixml (1.9-1exp1) experimental; urgency=medium

  * Team upload
  * Refresh symbols file
  * Upload to experimental with some debugging code

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 30 Jul 2018 09:40:16 +0200

pugixml (1.9-1) unstable; urgency=medium

  * Team upload
  * Move vcs to salsa.d.o
  * Bump std-version to 4.1.5, no changes required
  * New upstream release (Closes: #904803)
  * Patch refresh
  * Update copyright file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Jul 2018 09:07:01 +0200

=== debian/control ===
--- 
+++ 
@@ -9,10 +9,10 @@
  pkg-kde-tools
 Maintainer: Vasudev Kamath <vasudev@copyninja.info>
 Uploaders: Jonas Smedegaard <dr@jones.dk>
-Standards-Version: 4.1.1
-Homepage: http://pugixml.org/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/pugixml.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/pugixml.git
+Standards-Version: 4.1.5
+Homepage: https://pugixml.org/
+Vcs-Git: https://salsa.debian.org/debian/pugixml.git
+Vcs-Browser: https://salsa.debian.org/debian/pugixml
 
 Package: libpugixml1v5
 Section: libs

=== debian/rules ===
--- 
+++ 
@@ -80,7 +80,7 @@
 		--override s/$(lib)$(major)-dev/$(lib)-dev/ \
 		--movedev "debian/tmp/usr/include/*" usr/include/ \
 		--movedev "debian/tmp/usr/lib/*/cmake/pugixml/*" \
-			usr/share/$(lib)-dev/cmake \
+			/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/pugixml \
 		--movedev "debian/tmp/usr/lib/pkgconfig/*" \
 			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
 		debian/tmp/usr/lib/*/$(lib).so

## pugixml 1.10

=== Makefile ===
--- 
+++ 
@@ -12,9 +12,9 @@
 EXECUTABLE=$(BUILD)/test
 
 VERSION=$(shell sed -n 's/.*version \(.*\).*/\1/p' src/pugiconfig.hpp)
-RELEASE=$(shell git ls-files src docs/*.html docs/*.css docs/samples docs/images scripts contrib CMakeLists.txt readme.txt)
+RELEASE=$(filter-out scripts/archive.py docs/%.adoc,$(shell git ls-files docs scripts src CMakeLists.txt readme.txt))
 
-CXXFLAGS=-g -Wall -Wextra -Werror -pedantic -Wundef -Wshadow -Wcast-align -Wcast-qual -Wold-style-cast
+CXXFLAGS=-g -Wall -Wextra -Werror -pedantic -Wundef -Wshadow -Wcast-align -Wcast-qual -Wold-style-cast -Wdouble-promotion
 LDFLAGS=
 
 ifeq ($(config),release)
@@ -27,13 +27,8 @@
 endif
 
 ifeq ($(config),sanitize)
-	CXXFLAGS+=-fsanitize=address
-	LDFLAGS+=-fsanitize=address
-
-	ifneq ($(shell uname),Darwin)
-		CXXFLAGS+=-fsanitize=undefined
-		LDFLAGS+=-fsanitize=undefined
-	endif
+	CXXFLAGS+=-fsanitize=address,undefined -fno-sanitize=float-divide-by-zero,float-cast-overflow -fno-sanitize-recover=all
+	LDFLAGS+=-fsanitize=address,undefined
 endif
 
 ifeq ($(config),analyze)
@@ -61,17 +56,17 @@
 test: $(EXECUTABLE)
 	-@find $(BUILD) -name '*.gcda' -exec rm {} +
 	./$(EXECUTABLE)
-	@gcov -o $(BUILD)/src/ pugixml.cpp.gcda | sed -e '/./{H;$!d;}' -e 'x;/pugixml.cpp/!d;'
+	@gcov -b -o $(BUILD)/src/ pugixml.cpp.gcda | sed -e '/./{H;$!d;}' -e 'x;/pugixml.cpp/!d;'
 	@find . -name '*.gcov' -and -not -name 'pugixml.cpp.gcov' -exec rm {} +
+	@sed -i -e "s/#####\(.*\)\(\/\/ unreachable.*\)/    1\1\2/" pugixml.cpp.gcov
 else
 test: $(EXECUTABLE)
 	./$(EXECUTABLE)
 endif
 
-fuzz:
-	@mkdir -p $(BUILD)
-	$(AFL)/afl-clang++ tests/fuzz_parse.cpp tests/allocator.cpp src/pugixml.cpp $(CXXFLAGS) -o $(BUILD)/fuzz_parse
-	$(AFL)/afl-fuzz -i tests/data_fuzz_parse -o $(BUILD)/fuzz_parse_out -x $(AFL)/testcases/_extras/xml/ -- $(BUILD)/fuzz_parse @@
+fuzz_%: $(BUILD)/fuzz_%
+	@mkdir -p build/$@
+	$< build/$@ tests/data_fuzz_$* -max_len=1024 -dict=tests/fuzz_$*.dict
 
 clean:
 	rm -rf $(BUILD)
@@ -82,10 +77,14 @@
 
 build/pugixml-%: .FORCE | $(RELEASE)
 	@mkdir -p $(BUILD)
-	python tests/archive.py $@ pugixml-$(VERSION) $|
+	TIMESTAMP=`git show v$(VERSION) -s --format=%ct` && python scripts/archive.py $@ pugixml-$(VERSION) $$TIMESTAMP $|
 
 $(EXECUTABLE): $(OBJECTS)
 	$(CXX) $(OBJECTS) $(LDFLAGS) -o $@
+
+$(BUILD)/fuzz_%: tests/fuzz_%.cpp src/pugixml.cpp
+	@mkdir -p $(BUILD)
+	$(CXX) $(CXXFLAGS) -fsanitize=address,fuzzer $^ -o $@
 
 $(BUILD)/%.o: %
 	@mkdir -p $(dir $@)

=== debian/changelog ===
pugixml (1.10-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Repository, Repository-
    Browse.

  [ Gianfranco Costamagna ]
  * Team upload (salsa.d.o/debian namespace)
  * Bump copyright years
  * New upstream version 1.10
  * Disable patches now addressed upstream:
    - 2001-enable_staticlib_generation.patch
    - 2003-static_link_tests.patch
    - 2004-do_not_install_includes_in_versioned_dir.patch
    - disable-failing-test.patch
  * Refresh privacy patch
  * Bump std-version to 4.5.0, no changes required
  * Adapt grep to find new VERSION instead of SOVERSION
    (the latter is derived from PROJECT_VERSION, set with project keyword)
  * Add patch to make sure the output is correctly called
  * Don't move pkgconfig files anymore, they are ship in the correct location now

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 07 Feb 2020 11:36:49 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  pkg-kde-tools
 Maintainer: Vasudev Kamath <vasudev@copyninja.info>
 Uploaders: Jonas Smedegaard <dr@jones.dk>
-Standards-Version: 4.1.5
+Standards-Version: 4.5.0
 Homepage: https://pugixml.org/
 Vcs-Git: https://salsa.debian.org/debian/pugixml.git
 Vcs-Browser: https://salsa.debian.org/debian/pugixml

## pugixml 1.11.4

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 EXECUTABLE=$(BUILD)/test
 
 VERSION=$(shell sed -n 's/.*version \(.*\).*/\1/p' src/pugiconfig.hpp)
-RELEASE=$(filter-out scripts/archive.py docs/%.adoc,$(shell git ls-files docs scripts src CMakeLists.txt readme.txt))
+RELEASE=$(filter-out scripts/archive.py docs/%.adoc,$(shell git ls-files docs scripts src CMakeLists.txt LICENSE.md readme.txt))
 
 CXXFLAGS=-g -Wall -Wextra -Werror -pedantic -Wundef -Wshadow -Wcast-align -Wcast-qual -Wold-style-cast -Wdouble-promotion
 LDFLAGS=
@@ -77,7 +77,7 @@
 
 build/pugixml-%: .FORCE | $(RELEASE)
 	@mkdir -p $(BUILD)
-	TIMESTAMP=`git show v$(VERSION) -s --format=%ct` && python scripts/archive.py $@ pugixml-$(VERSION) $$TIMESTAMP $|
+	TIMESTAMP=`git show v$(VERSION) -s --format=%ct` && python3 scripts/archive.py $@ pugixml-$(VERSION) $$TIMESTAMP $|
 
 $(EXECUTABLE): $(OBJECTS)
 	$(CXX) $(OBJECTS) $(LDFLAGS) -o $@

=== debian/changelog ===
pugixml (1.11.4-1) unstable; urgency=medium

  * Team upload (salsa.d.o/debian namespace)
  * New upstream version 1.11.4

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 23 Dec 2020 08:27:40 +0100

pugixml (1.11.3-1) unstable; urgency=medium

  * Team upload (salsa.d.o/debian namespace)
  * New upstream version 1.11.3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 19 Dec 2020 23:16:32 +0100

pugixml (1.11.2-1) unstable; urgency=medium

  * Team upload (salsa.d.o/debian namespace)
  * New upstream version 1.11.2
  * Update SymbolsHelper-Confirmed for new version (Closes: #977602)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 18 Dec 2020 09:43:06 +0100

pugixml (1.11-1) unstable; urgency=medium

  * Team upload (salsa.d.o/debian namespace)
  * New upstream version 1.11
  * Update symbols for new release
  * Refresh privacy patch
  * Drop two patches now upstream

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 04 Dec 2020 19:40:40 +0100

pugixml (1.10-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Team upload (salsa.d.o/debian namespace)

  [ Debian Janitor ]
  * Wrap long lines in changelog entries: 1.10-1.
  * Set upstream metadata fields: Bug-Submit.

  [ Helmut Grohne ]
  * Multiarchify -dev and -doc. (Closes: #970683)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Nov 2020 12:26:45 +0100

=== debian/control ===
--- 
+++ 
@@ -45,6 +45,7 @@
 Depends: libpugixml1v5 (= ${binary:Version}),
  ${misc:Depends},
  ${devlibs:Depends}
+Multi-Arch: same
 Description: Light-weight C++ XML processing library (development)
  pugixml is a lightweight C++ XML processing library with XPath
  support. It features:
@@ -62,6 +63,7 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: Light-weight C++ XML processing library (documentation)
  pugixml is a lightweight C++ XML processing library with XPath
  support. It features:

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 # This needs to declared/run before including CDBS snippets
 stem = $(DEB_SOURCE_PACKAGE)
-major := $(shell grep -Po '\bSOVERSION +\K\d+' CMakeLists.txt)
+major := $(shell grep -Po '\bpugixml VERSION +\K\d+' CMakeLists.txt)
 lib = lib$(stem)
 # TODO: drop v5 suffix when major version > 1
 pkg-lib = lib$(stem)$(major)v5
@@ -46,7 +46,7 @@
 export DPKG_GENSYMBOLS_CHECK_LEVEL=$(if $(EXP_RELEASE),0,1)
 
 # Build the shared library
-DEB_CMAKE_EXTRA_FLAGS += -DBUILD_PKGCONFIG=1 -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)
+DEB_CMAKE_EXTRA_FLAGS += -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) -DBUILD_SHARED_AND_STATIC_LIBS=ON -DUSE_VERSIONED_LIBDIR=OFF
 ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
 DEB_CMAKE_EXTRA_FLAGS += -DBUILD_TESTS=1
 endif
@@ -81,8 +81,8 @@
 		--movedev "debian/tmp/usr/include/*" usr/include/ \
 		--movedev "debian/tmp/usr/lib/*/cmake/pugixml/*" \
 			/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/pugixml \
-		--movedev "debian/tmp/usr/lib/pkgconfig/*" \
-			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
+		--movedev "debian/tmp/usr/lib/*/pkgconfig/*" \
+			/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
 		debian/tmp/usr/lib/*/$(lib).so
 		touch $@
 clean::

=== debian/watch ===
version = 3
https://github.com/zeux/pugixml/tags .*/archive/v?(\d[\d.]+)\.tar\.gz
